routes/web.php
<?php

declare(strict_types=1);

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::prefix('install')->name('install.')->group(function (): void {
    Route::get('/', [\App\Http\Controllers\Install\InstallController::class, 'verifyConnectivity'])->name('verify-connectivity');
    Route::post('/', [\App\Http\Controllers\Install\InstallController::class, 'store'])->name('store');
    Route::get('/param/admin', [\App\Http\Controllers\Install\InstallController::class, 'administrateur'])->name('administrateur');
    Route::get('/param/wifi', [\App\Http\Controllers\Install\InstallController::class, 'wifi'])->name('wifi');
});
Route::get('/test', function () {
    dd(database_path());
});

Route::middleware(["installed"])->group(function (): void {
    Route::get("/", [\App\Http\Controllers\BaseController::class, 'index']);
    Route::get('/box/status', [\App\Http\Controllers\BaseController::class, 'box_status'])->name('box_status');
    Route::get('/box/download', [\App\Http\Controllers\BaseController::class, 'box_download'])->name('box_download');
});

app/Http/Controllers/Install/InstallController.php
<?php

declare(strict_types=1);

namespace App\Http\Controllers\Install;

use App\Http\Controllers\Controller;
use App\Models\Config;
use App\Models\User;
use App\Models\Wifi;
use Illuminate\Http\Request;
use Hash;

final class InstallController extends Controller
{
    public function verifyConnectivity()
    {
        return view('install.verif_connectivity');
    }

    public function administrateur()
    {
        return view('install.administrateur');
    }

    public function wifi()
    {
        return view('install.wifi');
    }

    public function store(Request $request)
    {
        return match ($request->get('action')) {
            "paramAdmin" => $this->paramAdmin($request),
            "paramWifi" => $this->paramWifi($request)
        };
    }

    private function paramAdmin(Request $request)
    {
        User::create([
            "name" => $request->get('name'),
            "password" => Hash::make($request->get('password'))
        ]);

        return redirect()->route('install.wifi');
    }

    private function paramWifi(Request $request)
    {
        $wifis = Wifi::all();

        foreach ($wifis as $wifi) {
            $wifi->update([
                "ssid" => $request->get('ssid'),
                "key" => encrypt($request->get('key'))
            ]);
        }

        Config::query()->first()->update(["installer" => true]);

        return redirect()->to('/');
    }
}

app/Http/Controllers/Install/TransmissionController.php
<?php

namespace App\Http\Controllers\Install;

use App\Http\Controllers\Controller;
use App\Models\Config;
use App\Service\ShellCommand;
use Transmission\Client;


class TransmissionController extends Controller
{
    //Installation du service transmission par docker
    public function install()
    {
        try {
            ShellCommand::execute("docker pull lscr.io/linuxserver/transmission:latest");
            return response()->json();
        } catch (\Exception $exception) {
            return response()->json($exception, 500);
        }
    }

    public function start_t()
    {
        try {
            $install = ShellCommand::execute("docker run -d \
  --name=transmission \
  -e PUID=1000 \
  -e PGID=1000 \
  -e TZ=Europe/London \
  -e TRANSMISSION_WEB_HOME=/combustion-release/ `#optional` \
  -p 9091:9091 \
  -p 51413:51413 \
  -p 51413:51413/udp \
  -v " . public_path('/storage/download') . "/data:/config \
  -v " . public_path('/storage/download') . "/downloads:/downloads \
  -v " . public_path('/storage/download') . "/watch:/watch \
  --restart unless-stopped \
  lscr.io/linuxserver/transmission:latest");
            return response()->json();
        } catch (\Exception $exception) {
            return response()->json($exception, 500);
        }
    }

    public function install_php()
    {
        try {
            $cmd = ShellCommand::execute("cd ../ && composer require mmockelyn/php-transmission --no-interaction --ignore-platform-reqs");
            return response()->json($cmd);
        }catch (\Exception $exception) {
            return response()->json($exception, 500);
        }
    }

    public function test_transmission()
    {
        try {
            fsockopen(config('app.app_ip').':9091');
            try {
                $transmission = new Client(config('app.app_ip'), 9091);
                $transmission->get();
                Config::query()->first()->update(["transmission_install" => true]);
                return response()->json();
            }catch (\Exception $exception) {
                return response()->json($exception->getMessage(), 500);
            }
        }catch (\Exception $exception) {
            return response()->json($exception->getMessage(), 500);
        }
    }

}

resources/views/install/administrateur.blade.php
@extends("install.layout")

@section("content")
    <!--begin::Wrapper-->
    <div class="card card-flush w-lg-650px py-5">
        <div class="card-body py-15 py-lg-10">
            <!--begin::Logo-->
            <div class="mb-14">
                <a href="/install" class="">
                    <img alt="Logo" src="/storage/logo_carre.png" class="h-100px" />
                </a>
            </div>
            <!--end::Logo-->
            <!--begin::Title-->
            <h1 class="fw-bolder text-gray-900 mb-5">Configuration 1/2</h1>
            <!--end::Title-->
            <!--begin::Message-->
            <div class="fs-6 fw-semibold text-gray-500 mb-10 mt-3">
                Administrateur
            </div>

            <form action="{{ route('install.store') }}" class="my-5" method="POST">
                @csrf
                <input type="hidden" name="action" value="paramAdmin">
                <x-form.input
                    name="name"
                    label="Pseudo"
                    value="Administrateur"
                    required="true" />

                <x-form.input
                    type="password"
                    name="password"
                    label="Mot de passe"
                    required="true" />

                <x-form.button />
            </form>
            <!--end::Message-->
            <!--begin::Illustration-->
            <div class="mb-0">
                <img src="assets/media/auth/ok.png" class="mw-100 mh-300px theme-light-show" alt="" />
                <img src="assets/media/auth/ok-dark.png" class="mw-100 mh-300px theme-dark-show" alt="" />
            </div>
            <!--end::Illustration-->
        </div>
    </div>
    <!--end::Wrapper-->
@endsection

@section("script")
    <script type="text/javascript">
        let notifyCharge = document.querySelector("#notifyCharge")

        notifyCharge.innerHTML = '';

        window.setTimeout(() => {
            notifyCharge.innerHTML = "Chargement des informations..."
            window.setTimeout(() => {
                notifyCharge.innerHTML = "Vérification des informations..."

                window.setTimeout(() => {
                    notifyCharge.innerHTML = "Vérification de la connectivité avec FINTECH TELECOM..."
                    window.setTimeout(() => {
                        window.location.href='/install/param/admin'
                    }, 8000)
                }, 5800)
            }, 2500)
        }, 100)
    </script>
@endsection

resources/views/install/layout.blade.php
<!DOCTYPE html>
<html lang="en">
<head><base href="../../"/>
    <title>{{ config('app.name') }}</title>
    <meta charset="utf-8" />
    <link rel="shortcut icon" href="/assets/media/logos/favicon.ico" />
    <!--begin::Fonts(mandatory for all pages)-->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Inter:300,400,500,600,700" />
    <!--end::Fonts-->
    <!--begin::Global Stylesheets Bundle(mandatory for all pages)-->
    <link href="/assets/plugins/global/plugins.bundle.css" rel="stylesheet" type="text/css" />
    <link href="/assets/css/style.bundle.css" rel="stylesheet" type="text/css" />
    <!--end::Global Stylesheets Bundle-->
</head>
<!--end::Head-->
<!--begin::Body-->
<body id="kt_body" class="app-blank app-blank bgi-size-cover bgi-position-center bgi-no-repeat">
<!--begin::Theme mode setup on page load-->
<script>var defaultThemeMode = "light"; var themeMode; if ( document.documentElement ) { if ( document.documentElement.hasAttribute("data-theme-mode")) { themeMode = document.documentElement.getAttribute("data-theme-mode"); } else { if ( localStorage.getItem("data-theme") !== null ) { themeMode = localStorage.getItem("data-theme"); } else { themeMode = defaultThemeMode; } } if (themeMode === "system") { themeMode = window.matchMedia("(prefers-color-scheme: dark)").matches ? "dark" : "light"; } document.documentElement.setAttribute("data-theme", themeMode); }</script>
<!--end::Theme mode setup on page load-->
<!--begin::Root-->
<div class="d-flex flex-column flex-root" id="kt_app_root">
    <!--begin::Page bg image-->
    <style>body { background-image: url('/storage/finbox_os_wall.png'); } [data-theme="dark"] body { background-image: url('/storage/finbox_os_wall.png'); }</style>
    <!--end::Page bg image-->
    <!--begin::Authentication - Signup Welcome Message -->
    <div class="d-flex flex-column flex-center flex-column-fluid">
        <!--begin::Content-->
        <div class="d-flex flex-column flex-center text-center p-10">
            @yield("content")
        </div>
        <!--end::Content-->
    </div>
    <!--end::Authentication - Signup Welcome Message-->
</div>
<!--end::Root-->
<!--begin::Javascript-->
<script>var hostUrl = "assets/";</script>
<!--begin::Global Javascript Bundle(mandatory for all pages)-->
<script src="/assets/plugins/global/plugins.bundle.js"></script>
<script src="/assets/js/scripts.bundle.js"></script>
@yield("script")
<!--end::Global Javascript Bundle-->
<!--end::Javascript-->
</body>
<!--end::Body-->
</html>

resources/views/install/verif_connectivity.blade.php
@extends("install.layout")

@section("content")
    <!--begin::Wrapper-->
    <div class="card card-flush w-lg-650px py-5">
        <div class="card-body py-15 py-lg-10">
            <!--begin::Logo-->
            <div class="mb-14">
                <a href="/install" class="">
                    <img alt="Logo" src="/storage/logo_carre.png" class="h-100px" />
                </a>
            </div>
            <!--end::Logo-->
            <!--begin::Title-->
            <h1 class="fw-bolder text-gray-900 mb-5">Bienvenue</h1>
            <!--end::Title-->
            <!--begin::Message-->
            <i id="notifyIcon" class="fa fa-spinner fa-spin fs-2tx"></i>
            <div class="fs-6 fw-semibold text-gray-500 mb-10 mt-3" id="notifyCharge">
                <strong>Etape 1:</strong> Démarrage des composants
            </div>
            <!--end::Message-->
            <!--begin::Illustration-->
            <div class="mb-0">
                <img src="assets/media/auth/ok.png" class="mw-100 mh-300px theme-light-show" alt="" />
                <img src="assets/media/auth/ok-dark.png" class="mw-100 mh-300px theme-dark-show" alt="" />
            </div>
            <!--end::Illustration-->
        </div>
    </div>
    <!--end::Wrapper-->
@endsection

@section("script")
    <script type="text/javascript">
        let notifyIcon = document.querySelector("#notifyIcon")
        let notifyCharge = document.querySelector("#notifyCharge")

        //notifyCharge.innerHTML = '';

        setTimeout(() => {
            $.ajax("/api/start/component")
                .done(() => {
                    $(notifyCharge).fadeOut()
                    notifyCharge.innerHTML = '<strong>Etape 2:</strong> Recherche du signal';
                    $(notifyCharge).fadeIn()

                    $.ajax('/api/start/signal')
                        .done(() => {
                            $(notifyCharge).fadeOut()
                            notifyCharge.innerHTML = '<strong>Etape 3:</strong> Signal trouvé, établissement de la connexion';
                            $(notifyCharge).fadeIn()

                            $.ajax("/api/start/connexion")
                                .done((data) => {
                                    console.log(data)
                                    if(data != 500) {
                                        $(notifyCharge).fadeOut()
                                        notifyCharge.innerHTML = '<strong>Etape 4:</strong> Authentification de la Finbox';
                                        $(notifyCharge).fadeIn()

                                        $.ajax("/api/start/authentification")
                                            .done((data) => {
                                                $(notifyCharge).fadeOut()
                                                notifyCharge.innerHTML = '<strong>Etape 5:</strong> Connexion établie, obtention des informations serveur.';
                                                $(notifyCharge).fadeIn()


                                                $.ajax("/api/start/recuperation")
                                                    .done((data) => {
                                                        $(notifyCharge).fadeOut()
                                                        notifyCharge.innerHTML = '<strong>Etape 6:</strong> Vérification du logiciel interne et téléchargement si nécessaire.';
                                                        $(notifyCharge).fadeIn()
                                                        $.ajax('/api/start/firmware')
                                                            .done((data) => {
                                                                $(notifyCharge).fadeOut()
                                                                window.location.href="/install/param/admin"
                                                            })
                                                    })
                                            })
                                    } else {
                                        notifyIcon.classList.remove('fa-spin')
                                        notifyIcon.classList.remove('fa-spinner')
                                        notifyIcon.classList.add('fa-xmark-circle')
                                        notifyIcon.classList.add('text-danger')
                                        notifyCharge.innerHTML = "Connexion impossible"
                                    }

                                })

                        })
                        .fail(() => {
                            notifyIcon = '<i id="notifyIcon" class="fa fa-xmark-circle text-danger fs-2tx"></i>'
                        })
                })
                .fail(() => {
                    notifyIcon = '<i id="notifyIcon" class="fa fa-xmark-circle text-danger fs-2tx"></i>'
                })
        }, 100)

    </script>
@endsection

resources/views/install/wifi.blade.php
@extends("install.layout")

@section("content")
    <!--begin::Wrapper-->
    <div class="card card-flush w-lg-650px py-5">
        <div class="card-body py-15 py-lg-10">
            <!--begin::Logo-->
            <div class="mb-14">
                <a href="/install" class="">
                    <img alt="Logo" src="/storage/logo_carre.png" class="h-100px" />
                </a>
            </div>
            <!--end::Logo-->
            <!--begin::Title-->
            <h1 class="fw-bolder text-gray-900 mb-5">Configuration 2/2</h1>
            <!--end::Title-->
            <!--begin::Message-->
            <div class="fs-6 fw-semibold text-gray-500 mb-10 mt-3">
                Wifi
            </div>

            <form action="{{ route('install.store') }}" class="my-5" method="POST">
                @csrf
                <input type="hidden" name="action" value="paramWifi">

                <x-form.input
                    name="ssid"
                    label="Identification de votre box"
                    value="{{ \App\Models\Wifi::query()->first()->ssid }}"
                    required="true" />

                <!--begin::Main wrapper-->
                <div class="fv-row" data-kt-password-meter="true">
                    <!--begin::Wrapper-->
                    <div class="mb-1">
                        <!--begin::Label-->
                        <label class="form-label fw-semibold fs-6 mb-2 required">
                            Clé Wifi
                        </label>
                        <!--end::Label-->

                        <!--begin::Input wrapper-->
                        <div class="position-relative mb-3">
                            <input class="form-control form-control-lg form-control-solid"
                                   type="password" placeholder="" name="key" autocomplete="off" value="{{ decrypt(\App\Models\Wifi::query()->first()->key) }}" required/>

                            <!--begin::Visibility toggle-->
                            <span class="btn btn-sm btn-icon position-absolute translate-middle top-50 end-0 me-n2"
                                  data-kt-password-meter-control="visibility">
                                <i class="bi bi-eye-slash fs-2"></i>

                                <i class="bi bi-eye fs-2 d-none"></i>
                            </span>
                            <!--end::Visibility toggle-->
                        </div>
                        <!--end::Input wrapper-->
                    </div>
                    <!--end::Wrapper-->
                </div>
                <!--end::Main wrapper-->

                <x-form.button />
            </form>
            <!--end::Message-->

            <!--begin::Illustration-->
            <div class="mb-0">
                <img src="assets/media/auth/ok.png" class="mw-100 mh-300px theme-light-show" alt="" />
                <img src="assets/media/auth/ok-dark.png" class="mw-100 mh-300px theme-dark-show" alt="" />
            </div>
            <!--end::Illustration-->
        </div>
    </div>
    <!--end::Wrapper-->
@endsection

@section("script")
    <script type="text/javascript">
        let notifyCharge = document.querySelector("#notifyCharge")

        notifyCharge.innerHTML = '';

        window.setTimeout(() => {
            notifyCharge.innerHTML = "Chargement des informations..."
            window.setTimeout(() => {
                notifyCharge.innerHTML = "Vérification des informations..."

                window.setTimeout(() => {
                    notifyCharge.innerHTML = "Vérification de la connectivité avec FINTECH TELECOM..."
                    window.setTimeout(() => {
                        window.location.href='/install/param/admin'
                    }, 8000)
                }, 5800)
            }, 2500)
        }, 100)
    </script>
@endsection